/*
 * engine.cpp
 *
 *  Created on: 27-05-2014
 *      Author: crm
 */

#include "application.h"

#include <SDL/SDL.h>

#include "resource.h"
#include "log.h"

#include "render/render.h"
#include "render/imagemanager.h"

using namespace Engine;

bool Application::init()
	{
	clear();

	run=false;

	if(SDL_Init(SDL_INIT_VIDEO)<0)
		{
		Log::fail("Render.init: Nie udalo sie zainicjowac SDL'a");
		return false;
		}

	run=true;
	cleared=false;

	keystate=SDL_GetKeyState(NULL);

	return true;
	}

void Application::update()
	{
	SDL_Event e;

	mousemotion=AVector(0, 0);

	while(SDL_PollEvent(&e))
		{
		switch(e.type)
			{
			case SDL_QUIT:
				run=false;
			break;

			case SDL_KEYDOWN:
				if( (e.key.keysym.sym==SDLK_F4 && (e.key.keysym.mod&KMOD_ALT)) ||
					 e.key.keysym.sym==SDLK_ESCAPE)
					run=false;
				/*if(e.key.keysym.sym==SDLK_RETURN && (e.key.keysym.mod&KMOD_ALT))
					{
					Log::info("Engine.update: Przelaczanie z/na pelny ekran");
					Render::toggleFullscreen();
					//ImageManager::reload();
					}*/
			break;

			case SDL_MOUSEMOTION:
				mousemotion=AVector(e.motion.xrel, e.motion.yrel);
			break;

			default:
				//
			break;
			}
		}

	//Render::update();

	dt=(SDL_GetTicks()-frametime)*0.001f;

	while(dt<0.014f)
		{
		SDL_Delay(1u);

		dt=(SDL_GetTicks()-frametime)*0.001f;
		}
	if(dt>0.1f)
		dt=0.1f;

	frametime=SDL_GetTicks();
	}

void Application::clear()
	{
	if(cleared)
		return;

	cleared=true;

	SDL_Quit();
	}

bool Application::running()
	{
	return run;
	}

float Application::delta()
	{
	return dt;
	}

bool Application::key(int sym)
	{
	return keystate[sym];
	}


AVector Application::getMouseMotion()
	{
	return mousemotion;
	}

AVector Application::getMousePosition()
	{
	int mx, my;
	SDL_GetMouseState(&mx, &my);

	return AVector(mx, my);
	}
