/*
 * sprite.cpp
 *
 *  Created on: 22-02-2013
 *      Author: crm
 */

#include "sprite.h"

#include "image.h"

using namespace Engine;

void Sprite::Direction::clear()
	{
	frames.clear();
	}

void Sprite::Animation::init()
	{
	for(unsigned i=0u; i<(int)DirectionName::COUNT; ++i)
		directions[i]=NULL;
	}

void Sprite::Animation::clear()
	{
	for(unsigned i=0u; i<(int)DirectionName::COUNT; ++i)
		{
		if(!directions[i])
			continue;

		delete directions[i];

		for(unsigned j=i+1u; j<(int)DirectionName::COUNT; ++j)	// Zerowanie zdublowanych wskaznikow
			if(directions[i]==directions[j])
				directions[j]=NULL;

		directions[i]=NULL;
		}

	init();
	}


void Sprite::Animation::addDirection(DirectionName dir, Direction *pdir)
	{
	// Jesli nie ma zadnych kierunkow, ustaw wszystkie na domyslny
	if(directions[(int)DirectionName::DEFAULT]==NULL)
		{
		for(unsigned i=0u; i<(int)DirectionName::COUNT; ++i)
			directions[i]=pdir;
		return;
		}

	directions[(int)dir]=pdir;
	}


bool Sprite::init(const std::string& sname)
	{
	name=sname;

	return true;
	}

void Sprite::clear()
	{
	setImage(NULL);

	for(unsigned i=0; i<animations.size(); ++i)
		delete animations[i];

	animations.clear();
	named.clear();
	}


unsigned Sprite::getAnimationID(const Animation *a) const
	{
	for(unsigned i=0u; i<animations.size(); ++i)
		if(animations[i]==a)
			return i;

	return 0u;
	}

unsigned Sprite::getAnimationID(const std::string& name) const
	{
	return getAnimationID(&getAnimation(name));
	}


unsigned Sprite::addAnimation(Animation *anim, const std::string& name)
	{
	animations.push_back(anim);

	if(name.length()>1)
		named[name]=anim;

	return animations.size();
	}
