/*
 * controller.cpp
 *
 *  Created on: 08-05-2016
 *      Author: crm
 */

#include "controller.h"

#include <SDL/SDL.h>

#include "database.h"

using namespace Game;

bool Controller::init(const std::string& configdb, const std::string& prefix)
	{
	Database db;

	const std::string CTRL_LEFT=    prefix+".left";
	const std::string CTRL_RIGHT=   prefix+".right";
	const std::string CTRL_JUMP=    prefix+".jump";
	const std::string CTRL_CONFIRM= prefix+".confirm";
	const std::string CTRL_PREVIOUS=prefix+".previous";
	const std::string CTRL_NEXT=    prefix+".next";

	db.load(configdb);

	keys[LEFT]=		db.getVal(CTRL_LEFT);
	keys[RIGHT]=	db.getVal(CTRL_RIGHT);
	keys[JUMP]=		db.getVal(CTRL_JUMP);
	keys[CONFIRM]=	db.getVal(CTRL_CONFIRM);
	keys[PREVIOUS]=	db.getVal(CTRL_PREVIOUS);
	keys[NEXT]=		db.getVal(CTRL_NEXT);

	db.clear();

	state=SDL_GetKeyState(NULL);

	update(0.0f);

	return true;
	}

bool Controller::init()
	{
	Database db;

	const std::string CTRL_LEFT=    "player_01.left";
	const std::string CTRL_RIGHT=   "player_01.right";
	const std::string CTRL_JUMP=    "player_01.jump";
	const std::string CTRL_CONFIRM= "player_01.confirm";
	const std::string CTRL_PREVIOUS="player_01.previous";
	const std::string CTRL_NEXT=    "player_01.next";

	db.setVal(CTRL_LEFT, SDLK_LEFT);
	db.setVal(CTRL_RIGHT, SDLK_RIGHT);
	db.setVal(CTRL_JUMP, SDLK_UP);
	db.setVal(CTRL_CONFIRM, SDLK_RETURN);
	db.setVal(CTRL_PREVIOUS, SDLK_UP);
	db.setVal(CTRL_NEXT, SDLK_DOWN);

	db.save("controls");
	db.clear();

	state=SDL_GetKeyState(NULL);

	return true;
	}

void Controller::update(float)
	{
	for(int i=0; i<COUNT; ++i)
		{
		change[i]=(pstate[i]==state[keys[i]])?0:(state[keys[i]])?1:-1;
		pstate[i]=state[keys[i]];
		}
	}

void Controller::clear()
	{
	//
	}

bool Controller::isPressed(Key c)
	{
	return state[keys[c]];
	}

bool Controller::onKeyDown(Key c)
	{
	return change[c]<0;
	}

bool Controller::onKeyUp(Key c)
	{
	return change[c]>0;
	}
