/*
 * fade.h
 *
 *  Created on: 16 maj 2016
 *      Author: crm
 */

#pragma once

#include <vector>

#include "../engine/render/spriteptr.h"

namespace Game
	{
	class Fade
		{
		private:
			struct Layer
				{
				Layer(): alpha(0.0f), target(0.0f), sprite() {}

				float alpha;
				float target;

				Engine::SpritePtr sprite;
				};

			std::vector<Layer*> layers;

		public:
			Fade() {}
			virtual ~Fade() {clear();}

			bool init();
			void update(float dt);
			void print();
			void clear();

			void set(unsigned layer, const Engine::SpritePtr& spr, float targetalpha, float alpha=-1);
			void set(unsigned layer, float targetalpha, float alpha=-1);

			float getPct(unsigned layer) const;
		};
	}
