/*
 * objecttemplate.h
 *
 *  Created on: 27 kwi 2016
 *      Author: crm
 */


#pragma once

#include <string>

#include "asmmath.h"

#include "../engine/render/spriteptr.h"

#include "box.h"
#include "collider.h"

namespace Game
	{
	class Object;

	class ObjectTemplate
		{
		protected:
			std::string name;
			std::string path;

			Box boundingbox;
			std::vector<Collider> colliders;
			Engine::SpritePtr sprite;

			float maxSpeed;

		public:
			ObjectTemplate(): boundingbox(), sprite(), maxSpeed(0.0f) {}
			virtual ~ObjectTemplate() {clear();}

			bool init(const std::string& path);
			void clear();

			//Object* instance(bool withColliders=true) const;

			std::string getName() const {return name;}
			std::string getPath() const {return path;}
			Box getBoundingBox() const {return boundingbox;}
			const std::vector<Collider>& getColliders() const {return colliders;}
			const Engine::SpritePtr& getSprite() const {return sprite;}
			float getMaxSpeed() const {return maxSpeed;}
		};
	}

